/**

*/
#ifndef INSTANCE_H
#define INSTANCE_H

#include <vector>
#include <string>
#include <iostream>
#include "commontype.h"

using namespace std;

class OldInstance{
public:
  int id;
  string pos; //in which chromosome?
  int nIsoforms;
  
  vector<string> isoformNames;
  vector<char> isoformStrands;
  vector<vector<int> > isoformStarts;
  vector<vector<int> > isoformEnds;

  //segments
  int nExons;
  vector<char> exonStrands;
  vector<int> exonLens;
  vector<long> exonStarts;
  vector<long> exonEnds;
  vector<int> exonFlags; //this is the flag at the end of the segs record in instance file

  vector<vector<int> > isoforms;
  vector<double> expLevels;//exp levels
  vector<vector<int> > seSegs;

  /**
  * The read pattern defines the different mapping patterns of a read. 
    Each pattern is a vector of 4 integers: [a,b,c,d].
    [a,b] is the starting and ending exon id of the first read, and
    [c,d] is the starting and ending exon id of the second read.
    If the read is single-ended, [c,d] should be -1.
    If a read is within one exon, [a,b] or [c,d] should be the same.
  */
  vector<vector<int> > readPattern;
  /**
  The read count stores the number of reads falling into each read pattern. The size of the readCount must be the same as readPattern.
  */
  vector<int> readCount;
};
int readOldInstance(string insFile, vector<OldInstance>& result, int nInstance);
void printOldInstance(ostream& out, OldInstance& ins);
int buildOldInstanceIndex(vector<OldInstance>& result);


/* Instance class currently using */
class Instance{
public:
  string id;
  string chr;
  char dir;
  range_t boundary;
  int readlen;
  md segs;
  mi refs;
  long nreads;
  mi sgtypes;
  vi sgcounts;
  vi sgdirs;
  
  //petypes 
  mi petypes;
  vi pecounts;
  mi pedists;
  mi pedistscount;

  /* Read from stream */
  int readFromStream(istream& ifs);
  /* Check if the boundaries are identical */
  bool checkBoundaryWithOtherInst(Instance& r);
};
/* Convert multiple instances to minst, and send to ostream 
ATTENTION: all paired-end types in vinst will be reshuffled.
*/
int inst2minst(ostream& out,vector<Instance>& vinst,vl& totalreads);

/* Sum up the Reads field in the Instance file */
long gettotalreads(string instfile);

#endif
