/*
 * mathlib.cpp
 * This file is part of isoLasso library; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; version 2.1 of the License.
 *
 *  Created on: 2011-10-14
 *      Author: daniel
 */
#include "mathlib.h"
#include "library.h"
#include <algorithm>
#include <functional>
#include <math.h>
#include <typeinfo>
#include <sstream>
#include <limits>
#include <numeric>

using namespace std;

const double PI = atan(1.)*4.;

double normpdf(double x, double mu, double sigma){
  double ff = - ((x - mu) * (x - mu));
  ff = ff / (2*sigma*sigma);
  double y = exp(ff);
  double d = sigma * sqrt((double)(2*PI));
  y = y / d;
  return y;
}


// the dummy copy
// does nothing
void LassoWithConstraint(vector<vector<double> > &X, vector<double> &y,double &lambda,NewInstance &ins,vector<string> &varargin, vector<double> &w, double &fval, long &exitflag){

  fval=0;
  exitflag=-1;

}
