#include <iostream>
#include <fstream>
#include <sstream>
#include "minst.h"

map<string, map<long,int> > MInst::ejdir;

void MInst::clear(){
  segment.clear();
  segcount.clear();
  segcvg.clear();
  segmaxcvg.clear();
  segp0.clear();
  /* type and type count */
  type.clear();
  typecount.clear();
  typedir.clear();


}
 
/*
Read a matrix like file and save the items into a vector of vector
This function reads a "block" data: the 1st line it encounters should indicate two items:
segname	nlines
indicating the name of the segment and the number of lines following the first line
*/
template<class T>
int fillMat(vector<vector<T> > &m,istream & ifs,string segname){
  //ifstream ifs(filename);
  string oneline;
  getline(ifs,oneline);
  stringstream ss0(oneline);
  string tsegname;
  int nline=0;
  ss0>>tsegname>>nline;
  if(tsegname!=segname){
    cerr<<"Error: inconsistent block name. Expect "<<segname<<", encounter "<<tsegname<<endl;
  }
  int n=0;
  while(true){
    if(n>=nline)break;
    getline(ifs,oneline);
    if(ifs.eof())break;
    if(oneline.size()>0 && oneline[0]=='#')continue;
    n++;
    vector<T> ct;
    stringstream ss(oneline);
    if(oneline[0]=='!'){
      string tmpstr;
      ss>>tmpstr;
    }
    while(!ss.eof()){
      T tp;
      ss>>tp;
      if(!ss.fail())
        ct.push_back(tp);
      else
        break;
    }
    m.push_back(ct);
  }
  //ifs.close();
  return 0;
}

/* Proceed the ifs to the next "Instance " line.
  return -1 if the stream hits the end
*/
int stream2NextIns(istream& ifs,  string & id){
  string chrins; string tid;
  string oneline;
  while(true){
    do{
      getline(ifs,oneline);
    }while(!ifs.eof()&& oneline.size()>0 && oneline[0]!='I');
    if(ifs.eof()|| oneline.size()==0) return -1;
    stringstream ss2(oneline);
    ss2>>chrins>>tid;
    if(chrins!="Instance"){
      tid="-1";
      continue;
    }else{
      id=tid;
      break;
    }
  }
  return 0;
}

int MInst::readFromStream(istream& ifs,string oid,int da, int dtotal){

 
  string oneline;
  getline(ifs,oneline);
  if(ifs.eof())return -1;
  string chrins, tid;
  stringstream ss(oneline);
  ss>>chrins>>tid;
    
  while(oid!="" && tid!=oid){
    if(stream2NextIns(ifs,tid)==-1)return -1;
  }
  int idasint=0;
  stringstream ssn(tid); ssn>>idasint;
  while(dtotal>0 && idasint%dtotal!=da){
    if(stream2NextIns(ifs,tid)==-1)return -1;
    stringstream ssn2(tid); ssn2>>idasint;
  }
  //if(chrins!="Instance"){
  //  cerr<<"Error: expect Instance here.\n";
  //  return -1;
  //}
  if(fillMat<long>(segment,ifs,"segment")==-1){
    cerr<<"Error reading segment."<<endl;
    return -1;
  }
  if(fillMat<int>(segcount,ifs,"segcount")==-1){
    cerr<<"Error reading segcount."<<endl;
    return -1;
  }
  if(fillMat<double>(segcvg,ifs,"segcvg")==-1){
    cerr<<"Error reading segcvg."<<endl;
    return -1;
  }
  if(fillMat<double>(segp0,ifs,"segp0")==-1){
    cerr<<"Error reading segp0."<<endl;
    return -1;
  }
  if(fillMat<double>(segmaxcvg,ifs,"segmaxcvg")==-1){
    cerr<<"Error reading segmaxcvg file."<<endl;
    return -1;
  }
  if(fillMat<int>(type,ifs,"sgtype")==-1){
    cerr<<"Error reading type file."<<endl;
    return -1;
  }
  //separate type direction
  for(int i=0;i<type.size();i++){
    typedir.push_back(type[i].back());
    type[i].pop_back();
  }
  if(fillMat<int>(typecount,ifs,"sgcount")==-1){
    cerr<<"Error reading typecount."<<endl;
    return -1;
  }
  if(fillMat<int>(petype,ifs,"petype")==-1){
    cerr<<"Error reading type file."<<endl;
    return -1;
  }
  for(int i=0;i<petype.size();i++)
    for(int j=0;j<petype[i].size();j++)
      petype[i][j]--;
  if(fillMat<int>(petypecount,ifs,"pecount")==-1){
    cerr<<"Error reading typecount."<<endl;
    return -1;
  }
  mi tmp;
  if(fillMat<int>(tmp,ifs,"readlen")==-1){
    cerr<<"Error reading readlen file."<<endl;
    return -1;
  }
  readlen=tmp[0];
  tmp.clear();
  if(fillMat<int>(tmp,ifs,"totalreads")==-1){
    cerr<<"Error reading totalreads."<<endl;
    return -1;
  }
  totalreads=tmp[0];
  vector<vector<string> > oinfo;
  if(fillMat<string>(oinfo,ifs,"otherinfo")==-1){
    cerr<<"Error reading otherinfo file."<<endl;
    return -1;
  }
  for(int i=0;i<oinfo.size();i++){
    if(oinfo[i].size()>=2){
      if(oinfo[i][0]=="Chr")
        chrname=oinfo[i][1];
      if(oinfo[i][0]=="Dir")
        switch(oinfo[i][1][0]){
          case '+': dir=1; break;
          case '-': dir=-1; break;
          default: dir=0;
        }
      if(oinfo[i][0]=="Refs"){
        //reading reference
        vi thisref(segment.size(),0);
        for(int j=1;j<oinfo[i].size();j++) {
          stringstream ss0(oinfo[i][j]);
          int ss0int; ss0>>ss0int;
          thisref[ss0int]=1;
        }
        refs.push_back(thisref);
        cout<<"Refs:";  for(int j=1;j<thisref.size();j++) if(thisref[j]>0) cout<<j<<" "; cout<<endl;
      }
    }
  }
  //write id
  //int idp=base.find("instance");
  //if(idp==-1)idp=0;
  //id=base.substr(idp);
  id=tid;
  
  return 0;

}



int MInst::readFromFile(char* prefix){

  string base(prefix);
  ifstream ifs(base.c_str());
  if(!ifs.is_open()){
    return -1;
  }
  int ret=readFromStream(ifs,"",0,0);
  
  ifs.close();
  
  return ret;

}

int MInst::check(){
  if(segment.size()!=segcount.size() 
    || segment.size()!=segcvg.size()
    || segment.size()!=segmaxcvg.size()
    || segment.size()!=segp0.size()){
    cerr<<"Error: incorrect segment size.\n";
    return -1;
  }
  if(type.size()!=typecount.size()){
    cerr<<"Error: incorrect type size.\n";
    return -1;
  }
  if(segment.size()>0){
    if(segment[0].size()!=2){
      cerr<<"Error: segment column must be 2.\n";
      return -1;
    }
    int nsz=segcount[0].size();
    if( nsz!=segcvg[0].size()
      || nsz!=segmaxcvg[0].size()
      || nsz!=segp0[0].size()){
        cerr<<"Error: incorrect sample size.\n";
        return -1;
      }
      if(typecount.size()>0){
        if(nsz!=typecount[0].size()){
          cerr<<"Error: incorrect sample size for typecount.\n";
          return -1;
        }
        if(type[0].size()!=segment.size()){
          cerr<<"Error: incorrect type size. segments: "<<segment.size()<<", type width: "<<type[0].size()<<"\n";
          return -1;
        }
      }
      
  }
  return 0;
}


/* convert type to index matrix. 
  The original matrix is 0-1 matrix. After conversion, only index of 1 elements are saved. */
void MInst::converttype(){
  //check
  for(int i=0;i<type.size();i++){
    for(int j=0;j<type[i].size();j++)
      if(type[i][j]!=0 && type[i][j]!=1)
        return;
  }
  for(int i=0;i<type.size();i++){
    vi tmp;
    for(int j=0;j<type[i].size();j++){
      if(type[i][j]==1) 
        tmp.push_back(j);
    }
    if(tmp.size()==0){
      cerr<<"Warning: empty types.\n";
    }
    type[i]=tmp;
  }
}

/* get the range of the current instance. Return range(-1,-1) if failed */
range_t MInst::getRange(){
  range_t t(-1,-1);
  if(segment.size()==0) return t;
  if(segment.front().size()!=2 || segment.back().size()!=2)return t;
  t.first=segment.front().front();
  t.second=segment.back().back();
  return t;
}


int MInst::readEJ(char* filename){
  ifstream ifs(filename);
  if(!ifs.is_open()){
    return -1;
  }

  while(true){
    string oneline;
    getline(ifs,oneline);
    if(ifs.eof())break;
    if(oneline.size()>0 && oneline[0]=='#')continue;
    stringstream ss(oneline);
    string chr;
    char ori;
    long starti,endi;
    string type;
    ss>>chr>>starti>>endi>>ori>>type;
    int dir;
    switch(ori){
      case '+': dir=1;break;
      case '-': dir=-1; break;
      default:  dir=0;
    }
    if(type[0]=='J'){
      ejdir[chr][starti]=dir;
    }
  }
  ifs.close();
  return 0;
}

/*
Fill the rcount matrix with direction sensitive
dir=1: positive; -1: negative; 0: don't care
*/
int MInst::fillRCount(mi& rcount,int tdir,int ns){
  int nsegs=getNSegs();
  rcount=mi(nsegs,vi(nsegs,0));
  //single type and typecount
  mi & tpm=type;
  mi & tpi=typecount;
  // set up
  int nalls=getNSamples();
  cout<<"NSAMPLES:"<<nalls<<",ns="<<ns<<endl;
  if(nalls<=0)return 0;
    
  vi tcsum;
  if(ns>=0 && ns<nalls){
    //sample specific
    tcsum.resize(tpi.size(),0);
    for(int i=0;i<tpi.size();i++) tcsum[i]=tpi[i][ns];
  }else{
    //use the average
    tcsum=getRowSum<int>(tpi);
  }
  cout<<"tpm:"<<type.size()<<", tpi:"<<typecount.size()<<",tcsum:"<<tcsum.size()<<endl;
  for(int i=0;i<tpm.size();i++){
    //check the direction of read types here?
    //cout<<"Type:"<<i<<",typedir:"<<typedir[i]<<",dir:"<<dir<<endl;
    if (typedir[i]* dir<0)continue;//notice that we use instance's dir here
    if(tpm[i].size()>0){
      if(tpm[i].size()==1){
        rcount[tpm[i][0]][tpm[i][0]]+=tcsum[i];
      }else{
        for(int j=0;j<tpm[i].size()-1;j++){
          int src=tpm[i][j],des=tpm[i][j+1];
          rcount[src][des]+=tcsum[i];
        }
        if(false){
          for(int j=0;j<tpm[i].size()-1;j++){
            int src=tpm[i][j],des=tpm[i][j+1];
            //check the direction; depreciated
            int thisdir=0;
            long srcright=segment[src][1]+1;
            long desleft=segment[des][0];
            int dsrc=0,ddes=0;
            if(ejdir[chrname].count(srcright)>0)
               dsrc=ejdir[chrname][srcright];
            if(ejdir[chrname].count(desleft)>0)
               ddes=ejdir[chrname][desleft];
        
            if( des>src+1 
                && dsrc!=0 
                && ddes!=0){
               if(dsrc==1 && ddes==-1) thisdir=1;
               else if(dsrc==-1 && ddes==1) thisdir=-1;
               else{
                 //disable this path
                 thisdir=-1*tdir;
               }
            }
            cout<<"dir:"<<tdir<<",src("<<src<<","<<srcright<<")="<<dsrc
               <<",des("<<des<<","<<desleft<<")="<<ddes<<",thisdir:"<<thisdir<<endl;
            if(thisdir*tdir>=0)
             rcount[src][des]+=tcsum[i];
          }
        }//end if(false)
      }
    }
  }//end for

  return 0;
}


/* get the number of reads of a given sample */
int MInst::getSampleRdCnt(int n){
  if(n>=getNSamples())return 0;
  int total=0;
  for(int i=0;i<getNSegs();i++){
    total+=segcount[i][n];
  }
  return total;
}
